const SystemFonts = require('system-font-families').default;
const fontkit = require('fontkit');
const fs = require('fs');
const systemFonts = new SystemFonts();
const fontList = [];
const result = {};

// フォント情報リスト取得
const fontFiles = systemFonts.getAllFontFilesSync();
for (const path of fontFiles) {
  const collection = fontkit.openSync(path);
  if (!collection.fonts) {
    fontList.push(collection);
  } else {
    collection.fonts.forEach((font) => {
      fontList.push(font);
    });
  }
}

//フォント情報リストから日本語フォント名を取得
for (const font of fontList) {
  fontkit.setDefaultLanguage('en');
  result[font.familyName] = {
    fullName: (() => {
      fontkit.setDefaultLanguage('ja');
      return font.fullName;
    })(),
    postscriptName: font.postscriptName
  };
}

// fonts.jsonファイルに書き込み
fs.writeFileSync('fonts.json', JSON.stringify(result));
console.log('output file: fonts.json');
