import $ from 'jquery';
import 'select2';
import 'select2/dist/css/select2.css';
import './ui.css';
const fonts = require('./../fonts.json');

window.onload = () => {
  const select = document.getElementById('select-font');

  // Figmaからメッセージ受信
  onmessage = (event) => {
    if (event.data.pluginMessage.init) {
      const fontList = event.data.pluginMessage.init;
      for (const font of fontList) {
        const fontName = `${font.fontName.family} ${font.fontName.style}`;
        if (fonts[fontName] || fonts[font.family]) {
          const option = document.createElement('option');
          option.value = JSON.stringify(font.fontName);
          option.innerHTML = fonts[fontName] ? fonts[fontName].fullName : (fonts[font.family] ? fonts[font.family].fullName : fontName);
          select.appendChild(option);
        }
      }
      $(select).select2({
        dropdownCssClass: ':all:',
        templateResult: function(state) {
          if (state.id) {
            const font = JSON.parse(state.id);
            const fontName = `${font.family} ${font.style}`;
            if (fonts[fontName]) {
              const style = ` style="font-family: '${fonts[fontName].postscriptName}', '${fonts[fontName].fullName}'"`;
              return $(`<span${style}>${state.text}</span><span${style}>文字もじモジ</span>`);
            } else if (fonts[font.family]) {
              const style = ` style="font-family: '${fonts[font.family].postscriptName}', '${fonts[font.family].fullName}'"`;
              return $(`<span${style}>${state.text}</span><span${style}>文字もじモジ</span>`);
            }
          } else {
            return state.text;
          }
        }
      });
      $(select).on('select2:select', (event) => {
        parent.postMessage({pluginMessage: {type: 'change', fontName: ((event.currentTarget.value === 'Mixed') ? 'Mixed' : JSON.parse(event.currentTarget.value))}}, '*');
      });
    } else {
      if (event.data.pluginMessage.font) {
        const font = event.data.pluginMessage.font;
        const fontName = `${font.family} ${font.style}`;
        if (fonts[fontName] || fonts[font.family]) {
          $(select).val(JSON.stringify(font)).trigger('change');
        } else {
          $('.select2-selection__rendered').html(fontName);
        }
      } else {
        $('.select2-selection__rendered').html('Mixed');
      }
    }
  }
};
